function [ rmse rmse_detrend slope] = compute_rmse_detrend( chi_recon, chi_true , msk)

% demeaning
chi_recon = chi_recon(msk~=0) - mean(chi_recon(msk~=0));
chi_true  = chi_true(msk~=0) - mean(chi_true(msk~=0));

% rmse calculation after demeaning in the masked region
rmse = 100 * norm( chi_recon  -  chi_true ) / norm(chi_true);

% slope computation
P = polyfit(chi_true,chi_recon,1);
slope = 1 / P(1);

P = robustfit(chi_true,chi_recon);  % this one gives a smaller RMSE
slope = 1 / P(2);

% slope computation
rmse_detrend = 100 * norm( chi_recon * slope  -  chi_true ) / norm(chi_true);
